Bug 2006590 - Review Request: earcut-hpp - Fast, header-only polygon triangulation
Summary: Review Request: earcut-hpp - Fast, header-only polygon triangulation
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Denis Fateyev
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-09-22 01:17 UTC by Ben Beasley
Modified: 2021-11-04 01:46 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-11-04 00:43:02 UTC
Type: ---
denis: fedora-review+


Attachments (Terms of Use)

Description Ben Beasley 2021-09-22 01:17:14 UTC
Spec URL: https://music.fedorapeople.org/earcut-hpp.spec
SRPM URL: https://music.fedorapeople.org/earcut-hpp-2.2.3-1.fc34.src.rpm
Description:

A C++ port of earcut.js, a fast, header-only polygon triangulation library.

The library implements a modified ear slicing algorithm, optimized by z-order
curve hashing and extended to handle holes, twisted polygons, degeneracies and
self-intersections in a way that doesn’t guarantee correctness of
triangulation, but attempts to always produce acceptable results for practical
data like geographical shapes.

It’s based on ideas from FIST: Fast Industrial-Strength Triangulation of
Polygons by Martin Held and Triangulation by Ear Clipping by David Eberly.

Fedora Account System Username: music

This is a mostly-straightforward header-only C++ library package. It will be used to package https://github.com/skogler/mapbox_earcut_python as python-mapbox-earcut; that, in turn, is a weak dependency, currently patched out, for the python-trimesh library.

Koji scratch builds:

F36: https://koji.fedoraproject.org/koji/taskinfo?taskID=76087127
F35: https://koji.fedoraproject.org/koji/taskinfo?taskID=76087212
F34: https://koji.fedoraproject.org/koji/taskinfo?taskID=76087213
F33: https://koji.fedoraproject.org/koji/taskinfo?taskID=76087214

Comment 1 Denis Fateyev 2021-10-25 21:20:08 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present.
Fedora-review reports a dist tag presence, but it seems a false positive and can be ignored.

- Architecture-specific "devel" packages are actually identical: they provide the same "earcut.hpp" source file version.
The difference is in the testing suite flow, but for an end-user they all provide the same content.
Please consider changing devel package to "noarch".


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "ISC License", "*No copyright*
     [generated file]", "SGI Free Software License B v2.0". 16 files have
     unknown license. Detailed output of licensecheck in
     /home/mock/sandbox/review/2006590-earcut-hpp/licensecheck.txt
Note: licensecheck reports "SGI Free Software License", but it's related to test suite only.

[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/include/mapbox(geometry-
     hpp-devel, mapbox-variant-devel, wagyu-devel)
Note: looks good. No dependency chain from packages above. Ownership rules are correct.

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
Note: requires %autochangelog macros working in advance, otherwise produces bogus results.

[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[!]: Package complies to the Packaging Guidelines
Note: all architecture-specific builds are identical, "noarch" usage is expected

[-]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
Note: provides should be no arch specific

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: earcut-hpp-devel-2.2.3-1.fc36.x86_64.rpm
          earcut-hpp-2.2.3-1.fc36.src.rpm
earcut-hpp-devel.x86_64: W: spelling-error %description -l en_US js -> dis, ks, j
earcut-hpp-devel.x86_64: W: spelling-error %description -l en_US degeneracies -> degenerates, degeneracy, DeGeneres
earcut-hpp-devel.x86_64: W: spelling-error %description -l en_US doesn -> does, does n
earcut-hpp.src: W: spelling-error %description -l en_US js -> dis, ks, j
earcut-hpp.src: W: spelling-error %description -l en_US degeneracies -> degenerates, degeneracy, DeGeneres
earcut-hpp.src: W: spelling-error %description -l en_US doesn -> does, does n
earcut-hpp.src:113: W: macro-in-%changelog %autochangelog
2 packages and 0 specfiles checked; 0 errors, 7 warnings.


Rpmlint (installed packages)
----------------------------
earcut-hpp-devel.x86_64: W: spelling-error %description -l en_US js -> dis, ks, j
earcut-hpp-devel.x86_64: W: spelling-error %description -l en_US degeneracies -> degenerates, degeneracy, DeGeneres
earcut-hpp-devel.x86_64: W: spelling-error %description -l en_US doesn -> does, does n
1 packages and 0 specfiles checked; 0 errors, 3 warnings.


Source checksums
----------------
https://github.com/mapbox/earcut.hpp/archive/v2.2.3/earcut.hpp-2.2.3.tar.gz :
  CHECKSUM(SHA256) this package     : f382616de763289c698f37ec3a5b9fcd3d6d821cbef0b3c72e43bdd909c81b5a
  CHECKSUM(SHA256) upstream package : f382616de763289c698f37ec3a5b9fcd3d6d821cbef0b3c72e43bdd909c81b5a


Requires
--------
earcut-hpp-devel (rpmlib, GLIBC filtered):


Provides
--------
earcut-hpp-devel:
    earcut-hpp-devel
    earcut-hpp-devel(x86-64)
    earcut-hpp-static



License check
--------

*No copyright*  [generated file]
--------------------------------
earcut.hpp-2.2.3/test/convert_tests.js
earcut.hpp-2.2.3/test/fixtures/bad_diagonals.cpp
earcut.hpp-2.2.3/test/fixtures/bad_hole.cpp
earcut.hpp-2.2.3/test/fixtures/boxy.cpp
earcut.hpp-2.2.3/test/fixtures/building.cpp
earcut.hpp-2.2.3/test/fixtures/collinear_diagonal.cpp
earcut.hpp-2.2.3/test/fixtures/degenerate.cpp
earcut.hpp-2.2.3/test/fixtures/dude.cpp
earcut.hpp-2.2.3/test/fixtures/eberly_3.cpp
earcut.hpp-2.2.3/test/fixtures/eberly_6.cpp
earcut.hpp-2.2.3/test/fixtures/empty_square.cpp
earcut.hpp-2.2.3/test/fixtures/hilbert.cpp
earcut.hpp-2.2.3/test/fixtures/hole_touching_outer.cpp
earcut.hpp-2.2.3/test/fixtures/hourglass.cpp
earcut.hpp-2.2.3/test/fixtures/issue107.cpp
earcut.hpp-2.2.3/test/fixtures/issue111.cpp
earcut.hpp-2.2.3/test/fixtures/issue119.cpp
earcut.hpp-2.2.3/test/fixtures/issue131.cpp
earcut.hpp-2.2.3/test/fixtures/issue135.cpp
earcut.hpp-2.2.3/test/fixtures/issue16.cpp
earcut.hpp-2.2.3/test/fixtures/issue17.cpp
earcut.hpp-2.2.3/test/fixtures/issue29.cpp
earcut.hpp-2.2.3/test/fixtures/issue34.cpp
earcut.hpp-2.2.3/test/fixtures/issue35.cpp
earcut.hpp-2.2.3/test/fixtures/issue45.cpp
earcut.hpp-2.2.3/test/fixtures/issue52.cpp
earcut.hpp-2.2.3/test/fixtures/issue83.cpp
earcut.hpp-2.2.3/test/fixtures/outside_ring.cpp
earcut.hpp-2.2.3/test/fixtures/rain.cpp
earcut.hpp-2.2.3/test/fixtures/self_touching.cpp
earcut.hpp-2.2.3/test/fixtures/shared_points.cpp
earcut.hpp-2.2.3/test/fixtures/simplified_us_border.cpp
earcut.hpp-2.2.3/test/fixtures/steiner.cpp
earcut.hpp-2.2.3/test/fixtures/touching2.cpp
earcut.hpp-2.2.3/test/fixtures/touching3.cpp
earcut.hpp-2.2.3/test/fixtures/touching4.cpp
earcut.hpp-2.2.3/test/fixtures/touching_holes.cpp
earcut.hpp-2.2.3/test/fixtures/water.cpp
earcut.hpp-2.2.3/test/fixtures/water2.cpp
earcut.hpp-2.2.3/test/fixtures/water3.cpp
earcut.hpp-2.2.3/test/fixtures/water3b.cpp
earcut.hpp-2.2.3/test/fixtures/water4.cpp
earcut.hpp-2.2.3/test/fixtures/water_huge.cpp
earcut.hpp-2.2.3/test/fixtures/water_huge2.cpp

ISC License
-----------
earcut.hpp-2.2.3/LICENSE

SGI Free Software License B v2.0
--------------------------------
earcut.hpp-2.2.3/test/comparison/libtess2/LICENSE.txt
earcut.hpp-2.2.3/test/comparison/libtess2/bucketalloc.c
earcut.hpp-2.2.3/test/comparison/libtess2/bucketalloc.h
earcut.hpp-2.2.3/test/comparison/libtess2/dict.c
earcut.hpp-2.2.3/test/comparison/libtess2/dict.h
earcut.hpp-2.2.3/test/comparison/libtess2/geom.c
earcut.hpp-2.2.3/test/comparison/libtess2/geom.h
earcut.hpp-2.2.3/test/comparison/libtess2/mesh.c
earcut.hpp-2.2.3/test/comparison/libtess2/mesh.h
earcut.hpp-2.2.3/test/comparison/libtess2/priorityq.c
earcut.hpp-2.2.3/test/comparison/libtess2/priorityq.h
earcut.hpp-2.2.3/test/comparison/libtess2/sweep.c
earcut.hpp-2.2.3/test/comparison/libtess2/sweep.h
earcut.hpp-2.2.3/test/comparison/libtess2/tess.c
earcut.hpp-2.2.3/test/comparison/libtess2/tess.h
earcut.hpp-2.2.3/test/comparison/libtess2/tesselator.h

Unknown or generated
--------------------
earcut.hpp-2.2.3/.clang-format
earcut.hpp-2.2.3/.gitmodules
earcut.hpp-2.2.3/.travis.yml
earcut.hpp-2.2.3/CHANGELOG.md
earcut.hpp-2.2.3/CMakeLists.txt
earcut.hpp-2.2.3/README.md
earcut.hpp-2.2.3/appveyor.yml
earcut.hpp-2.2.3/include/mapbox/earcut.hpp
earcut.hpp-2.2.3/test/bench.cpp
earcut.hpp-2.2.3/test/comparison/earcut.hpp
earcut.hpp-2.2.3/test/comparison/libtess2.hpp
earcut.hpp-2.2.3/test/fixtures/geometries.hpp
earcut.hpp-2.2.3/test/tap.cpp
earcut.hpp-2.2.3/test/tap.hpp
earcut.hpp-2.2.3/test/test.cpp
earcut.hpp-2.2.3/test/viz.cpp


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2006590
Buildroot used: fedora-rawhide-x86_64
Active plugins: C/C++, Shell-api, Generic
Disabled plugins: Haskell, R, PHP, Java, Ocaml, fonts, SugarActivity, Perl, Python
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 2 Ben Beasley 2021-10-25 21:44:14 UTC
Thanks for the review!

> - Dist tag is present.
> Fedora-review reports a dist tag presence, but it seems a false positive and can be ignored.

It’s actually confusingly trying to complain that the dist tag is not present, but it’s because it does not understand rpmautospec. It’s just looking for the %{?dist} macro in Release, and doesn’t understand that %autorelease includes the dist tag.

> - Architecture-specific "devel" packages are actually identical: they provide the same "earcut.hpp" source file version.
> The difference is in the testing suite flow, but for an end-user they all provide the same content.
> Please consider changing devel package to "noarch".

This seems reasonable—especially leaving the base package arched to run the tests on all architectures, while marking the -devel subpackage noarch—and I have used this approach on Python packages that have no compiled code but are prone to arch-dependent test failures.

However, for header-only library packages like this one, the guidelines actually forbid using noarch: https://docs.fedoraproject.org/en-US/packaging-guidelines/#_do_not_use_noarch

Comment 3 Denis Fateyev 2021-10-25 22:18:22 UTC
(In reply to Ben Beasley from comment #2)
> > - Architecture-specific "devel" packages are actually identical: they provide the same "earcut.hpp" source file version.
> > The difference is in the testing suite flow, but for an end-user they all provide the same content.
> > Please consider changing devel package to "noarch".
> 
> This seems reasonable—especially leaving the base package arched to run the
> tests on all architectures, while marking the -devel subpackage noarch—and I
> have used this approach on Python packages that have no compiled code but
> are prone to arch-dependent test failures.
> 
> However, for header-only library packages like this one, the guidelines
> actually forbid using noarch:
> https://docs.fedoraproject.org/en-US/packaging-guidelines/#_do_not_use_noarch

OK, I have just seen this requirement.
Honestly, it looks a bit incomplete in the guidelines: to put headers into arch-specific packages only to satisfy arch-specific tests, when the "library should have tests which should be run on all architectures" condition can be archived a better way. Also, there is no "install process may modify the installed headers depending on the build architecture" situation.
Anyway, the package is APPROVED.

Comment 4 Ben Beasley 2021-10-25 22:48:15 UTC
Thanks!

-----

> Honestly, it looks a bit incomplete in the guidelines: to put headers into arch-specific packages only to satisfy arch-specific tests, when the "library should have tests which should be run on all architectures" condition can be archived a better way.

Agreed!

> Also, there is no "install process may modify the installed headers depending on the build architecture" situation.

Also agreed. While it’s not always easy for the packager to tell if this is happening, there are plenty of other cases where noarch packages *are* allowed or encouraged but builder-arch-dependent differences can slip in anyway—perhaps chief among them, -doc subpackages. Besides, the tooling exists to reject arched builds when a noarch subpackage is not consistent across build architectures.

I think if the guidelines were changed to specify that only the *base* package of a header-only library must be arched, and the -devel package *may* be noarch, it would still satisfy all of the stated justifications for the current mandate.

Comment 5 Gwyn Ciesla 2021-10-26 13:32:33 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/earcut-hpp

Comment 6 Fedora Update System 2021-10-26 18:48:29 UTC
FEDORA-2021-bd7a8d5c08 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-bd7a8d5c08

Comment 7 Fedora Update System 2021-10-26 18:58:34 UTC
FEDORA-2021-361016c589 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-361016c589

Comment 8 Fedora Update System 2021-10-26 19:33:17 UTC
FEDORA-2021-398baa5563 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-398baa5563

Comment 9 Fedora Update System 2021-10-26 22:17:00 UTC
FEDORA-EPEL-2021-0afa7da545 has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2021-0afa7da545

Comment 10 Fedora Update System 2021-10-27 02:07:34 UTC
FEDORA-2021-398baa5563 has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-398baa5563 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-398baa5563

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2021-10-27 02:16:49 UTC
FEDORA-EPEL-2021-0afa7da545 has been pushed to the Fedora EPEL 8 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2021-0afa7da545

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2021-10-27 02:29:13 UTC
FEDORA-2021-361016c589 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-361016c589 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-361016c589

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2021-10-27 19:00:13 UTC
FEDORA-2021-bd7a8d5c08 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-bd7a8d5c08 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-bd7a8d5c08

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2021-11-04 00:43:02 UTC
FEDORA-EPEL-2021-0afa7da545 has been pushed to the Fedora EPEL 8 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 15 Fedora Update System 2021-11-04 01:23:20 UTC
FEDORA-2021-398baa5563 has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 16 Fedora Update System 2021-11-04 01:33:37 UTC
FEDORA-2021-361016c589 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 17 Fedora Update System 2021-11-04 01:46:02 UTC
FEDORA-2021-bd7a8d5c08 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.